from pyparsing import *

##TODO: this is a hack to get integers when not a float literal, better if
## I could get the parser to do this
def as_numeric(x):
    try:
        return int(x)
    except ValueError:
        return float(x)

# Define numbers
point = Literal('.')
e = CaselessLiteral('E')
plusorminus = Literal('+') | Literal('-')
number = Word(nums) 
integer = Combine(Optional(plusorminus) + number)
floatnumber = Combine(integer +
                      Optional(point + Optional(number)) +
                      Optional(e + integer)) .setParseAction(lambda t: as_numeric(t[0]))
operand = floatnumber

# Define operators
addop = oneOf("+ -")
multop = oneOf("* /")
expop = oneOf("** ^")

expr = operatorPrecedence(operand, 
    [
        (expop, 2, opAssoc.RIGHT),
        (multop, 2, opAssoc.LEFT),
        (addop, 2, opAssoc.LEFT)
    ]
)

